/**
 * aotu refresh java activity
 */
var path = require("path");
var file = require("../core/file.js");

var codePath;
var codeContent;

function init(url, platform) {
	switch (platform) {
		case 'android'://获取java文件，不敢动
			var gradlePath = url + '/app/src/main';

			var DOMParser = require('../core/xmldom/dom-parser').DOMParser;
			var xmlContent = file.read(path.join(gradlePath, "AndroidManifest.xml"));
			var doc = new DOMParser().parseFromString(xmlContent);
			var filePath = doc.documentElement.getElementsByTagName('manifest')._node.getAttribute('package').replace(/\./g, "/");
			var javaName;
			var activities = doc.documentElement.getElementsByTagName("activity");
			for (var i = 0; i < activities.length; i++) {
				var activity = activities[i];
				if (activity.hasAttribute("android:name") && activity.getAttribute("android:label") == "@string/app_name") {
					javaName = activity.getAttribute('android:name').replace(/\./g, "/");
					break;
				}
			}

			if (file.exists(codePath = path.join(gradlePath, "java", javaName + ".java")) || file.exists(codePath = path.join(gradlePath, "java", filePath, javaName + ".java"))) {
				codeContent = file.read(codePath);
			}
			else {
				codeContent = null;
			}
			break;
		case 'ios'://获取AppDelegate.mm文件
			var projectName = '';
			var fs = require('fs');
			var dirList = fs.readdirSync(url);
			dirList.some(function(item){
				var index = item.indexOf('.xcodeproj');
				if(index >= 0){
					projectName = item.substr(0, index);
					return true;
				}
			});
			codePath = path.join(url, projectName, 'AppDelegate.mm');
			if (file.exists(codePath)) {
				codeContent = file.read(codePath);
			}
			else {
				codeContent = null;
			}
			break;
	}
}

function changePublish(url, platform, versionFile) {
	init(url, platform);

	if (codeContent) {
		codeContent = codeContent.replace(/game_code_\w+.zip/, 'game_code_' + versionFile + '.zip');
		changeLoaderUrl(0, platform);
		file.save(codePath, codeContent);
	}
}

function changeBuild(url, platform) {
	init(url, platform);

	if (codeContent) {
		changeLoaderUrl(2, platform);
		file.save(codePath, codeContent);
	}
}

function changeLoaderUrl(type, platform){
	switch (platform) {
		case 'android':
			codeContent = codeContent.replace(/setLoaderUrl\((\s)*\d(\s)*\);/, 'setLoaderUrl(' + type + ');');
			break;
		case 'ios':
			codeContent = codeContent.replace(/setLoaderUrl:(\s)*\d(\s)*/, 'setLoaderUrl:' + type);
			break;
	}
}

exports.changePublish = changePublish;
exports.changeBuild = changeBuild;